diff -uwrN source/scripts/jmgUtility.h sourceold/scripts/jmgUtility.h
--- source/scripts/jmgUtility.h	2016-12-17 21:07:23.267015700 +1000
+++ sourceold/scripts/jmgUtility.h	2016-11-01 12:49:30.379435500 +1000
@@ -698,6 +698,7 @@
 	}
 };
 
+
 class NewObjectiveSystem
 {
 	bool objectiveStringIdsLoaded;
@@ -1932,7 +1933,6 @@
 * \WaterOpacity - How transparent the screen is while in this zone
 * \WaterMinViewDistance - The min distance that the fog shows up when underwater
 * \WaterMaxViewDistance - The max distance of the fog when underwater
-* \SwimmingSpeedMultiplier - Speed multiplier when in water
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -1999,7 +1999,6 @@
 	int waterZoneCount;
 	int lastWaterZoneId;
 	time_t lastDisplayTime;
-	float defaultSpeed;
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
@@ -2624,36 +2623,6 @@
 };
 
 /*!
-============================================================================================================================================================
-The objective system makes use of the following hard-coded string definitions, make sure to add them to your strings library if you plan on using my system:
-============================================================================================================================================================
-IDS_OBJ2_CANCELLED					%s mission objective canceled
-IDS_OBJ2_CANCELLED_NUMBERED			%s mission objective %d canceled
-IDS_OBJ2_LIST						%s Mission Objectives:
-IDS_OBJ2_NEW_OBJ					New %s mission objective:
-IDS_OBJ2_PRIORITY_0					Unknown
-IDS_OBJ2_PRIORITY_1					Primary
-IDS_OBJ2_PRIORITY_2					Secondary
-IDS_OBJ2_PRIORITY_3					Tertiary
-IDS_OBJ2_PRIORITY_4					Quaternary
-IDS_OBJ2_PRIORITY_5					Quinary
-IDS_OBJ2_PRIORITY_6					Senary
-IDS_OBJ2_PRIORITY_7					Septenary
-IDS_OBJ2_PRIORITY_8					Octonary
-IDS_OBJ2_PRIORITY_9					Nonary
-IDS_OBJ2_PRIORITY_10				Denary
-IDS_OBJ2_PRIORITY_11				Bonus
-IDS_OBJ2_STATE_0					Pending
-IDS_OBJ2_STATE_1					Accomplished
-IDS_OBJ2_STATE_2					Failed
-IDS_OBJ2_STATE_3					Hidden
-IDS_OBJ2_STATUS_CHANGED				%s mission objective %s
-IDS_OBJ2_STATUS_CHANGED_NUMBERED	%s mission objective %d %s
-IDS_OBJ2_UPDATED					%s mission objective updated:
-IDS_OBJ2_UPDATED_NUMBERED			%s mission objective %d updated:
-============================================================================================================================================================
-*/
-/*!
 * \brief Used to control a basic objective system
 * \ShowMarkersOnRadar - Should stars be shown on the radar
 * \PrimaryObjectiveModel - Visible 3d model to show for Primary Objectives
@@ -4385,210 +4354,3 @@
 class JMG_Utility_AI_Engineer_Ignore_Target : public ScriptImpClass {
 	void Created(GameObject *obj);
 };
-/*!
-* \brief Grants specified weapon to all players in range
-* \WeaponName - Name of the weapon to grant to the player
-* \Location - Location to grant the weapon at
-* \Range - Range from the location to grant the weapon
-* \EnableCustom - Custom to enable the scanning, parameter determines if its enabled or disabled 1 = enabled, 0 = disabled
-* \StartsEnabled - Should to script start running 1 = true, 0 = false
-* \Rate - Speed at which to scan, 0.0 will disable the repeated scanning and then only enable custom will trigger a scan
-* \SelectWeapon - Should the player pull out the weapon when its granted
-* \WeaponAmmo - Amount of ammo to grant with initial weapon grant
-* \RefillRate - How fast the gun should be refilled while in the zone
-* \RefillAmount - How much ammo to refill
-* \author jgray
-* \ingroup JmgUtility
-*/
-class JMG_Utility_Give_Weapon_In_Range : public ScriptImpClass
-{
-	float rate;
-	float refillRate;
-	float range;
-	Vector3 location;
-	bool enabled;
-	int enableCustom;
-	char weaponName[256];
-	bool selectWeapon;
-	int weaponAmmo;
-	int refillAmount;
-	void Created(GameObject *obj);
-	void Timer_Expired(GameObject *obj,int number);
-	void Custom(GameObject *obj,int message,int param,GameObject *sender);
-	void GrantWeapon();
-};
-
-/*!
-* \brief Needed for AI using JMG_Utility_AI_Follow_Player_On_Poke, this script controls the limits of how many bots each player can have following them
-* \MaxFollowers - Any value greater than 0 makes it so a player can only have that many followers at a time
-* \author jgray
-* \ingroup JmgUtility
-*/
-class JMG_Utility_AI_Follow_Player_On_Poke_Controller : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Destroyed(GameObject *obj);
-public:
-	static bool controllerPlaced;
-	static int maxFollowers;
-	static int followingPlayer[128];
-	JMG_Utility_AI_Follow_Player_On_Poke_Controller()
-	{
-		controllerPlaced = true;
-	}
-};
-
-/*!
-* \brief Makes an AI follow the player that pokes it, if the player dies it goes to its original position
-* \FollowDistance - How far should the AI follow the player
-* \FollowNearSpeed - How fast should the AI follow the player when it is near by
-* \FollowFarDistance - How far must the AI be away in order to run faster to the player
-* \FollowFarSpeed - How fast should the AI follow the player when it is far away
-* \FollowVeryFarDistance - How far must the AI be away in order to run faster to the player
-* \FollowVeryFarSpeed - How fast should the AI follow the player when it is far away
-* \FallBackWhenOutOfArmor - Should the AI return to its spawn location when it runs out of armor
-* \RunHomeSpeed - How fast should the AI run home
-* \HealWhileAtHomeLocation - The amount of health the AI regenerates while at its home location
-* \HUDMessagesColor - Color of the HUD messages that are displayed to the player that the AI is following (0.0 - 1.0)
-* \MessagePokeFollowerID - Message to display when a player pokes a follower, it displays the current number of followers out of total IE: %d/%d
-* \MessageFollowingYouID - Message to display if the player pokes the bot when it is already following them
-* \MessageFollowingPlayerID - Message to display to the player if they poke a bot that is following someone else
-* \MessageMaxFollowersID - Message to display if the player attempts to have more followers than allowed (message is formatted: You can only have %d creature%sfollowing you.)
-* \MessageHealingRequiredID - Message to display when the follower is hurt and has to heal before following again, only available when FallBackWhenOutOfArmor is on
-* \MessageFollowerLostID - Message to display when the player the follower is following wanders out of the pathfind zone
-* \MessageFollowerInjuredID - Message to display when the follower runs out of armor, FallBackWhenOutOfArmor must be on
-* \MessageFollowerKilledID - Message to display when the follower dies following someone
-* \SendCustomID - ID of the object customs should be sent to
-* \PokedCustom - Custom to send when the follower is poked and starts following
-* \LostCustom - Message to send if the follower gets lost
-* \InjuredCustom - Message to send when the follower gets injured, requires FallBackWhenOutOfArmor be on
-* \KilledCustom - Message to send if the follower is killed 
-* \HealedCustom - Message to send when the follower gets to full health, requires FallBackWhenOutOfArmor be on
-* \author jgray
-* \ingroup JmgUtility
-*/
-class JMG_Utility_AI_Follow_Player_On_Poke : public ScriptImpClass {
-	GameObject *lastFollow;
-	GameObject *lastTarget;
-	bool detached;
-	float followDistance;
-	float followNearSpeed;
-	float followFarSpeed;
-	float followFarDistance;
-	float followVeryFarSpeed;
-	float followVeryFarDistance;
-	float runHomeSpeed;
-	int actionUpdate;
-	float weaponRange;
-	float targetDistance;
-	int enemyId;
-	int pokerPlayerId;
-	int playerObjectId;
-	Vector3 homeLocation;
-	Vector3 lastLocation;
-	int enemySeen;
-	bool fallbackWithoutArmor;
-	float healWhileAtHomeLocation;
-	int sendCustomId;
-	int pokedCustom;
-	int lostCustom;
-	int killedCustom;
-	int healedCustom;
-	int injuredCustom;
-	Vector3 messageColor;
-	int messagePokeFollowerId;
-	char messagePokeFollower[220];
-	int messageFollowingYouId;
-	int messageFollowingPlayerId;
-	int messageMaxFollowersId;
-	char messageMaxFollowers[220];
-	int messageHealingRequiredId;
-	int messageFollowerInjuredId;
-	int messageFollowerKilledId;
-	int messageFollowerLostId;
-	bool hurt;
-	void Created(GameObject *obj);
-	void Enemy_Seen(GameObject *obj,GameObject *seen);
-	void Timer_Expired(GameObject *obj,int number);
-	void Damaged(GameObject *obj,GameObject *damager,float damage);
-	void Poked(GameObject *obj, GameObject *poker);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason reason);
-	void Destroyed(GameObject *obj);
-	void Detach(GameObject *obj);
-	void AttackTarget(GameObject *obj,GameObject *follow,GameObject *target,Vector3 location,float speed,float distance);
-	void GiveUpOnPlayer(GameObject *obj,bool pokeable);
-	void ForgetEnemy(GameObject *obj);
-	void SendCustom(GameObject *obj,int custom);
-	char *formatMaxFollowingString(const char *format,...);
-	void ShowPlayerMessage(GameObject *player,int stringId,Vector3 color);
-public:
-	JMG_Utility_AI_Follow_Player_On_Poke()
-	{
-		detached = false;
-		pokerPlayerId = 0;
-	}
-};
-
-/*!
-* \brief Damages the attached object and teleports it after a timed delay
-* \Delay - Amount of time in seconds to wait
-* \TeleportToObjectID - ID of the object to teleport to
-* \Location - Location to teleport to if no object ID was supplied 
-* \DamageAmount - Amount of damage to apply
-* \DamageWarhead - Warhead to use to damage the object
-* \DamageSelf - Should the applied damage count for the object the script is attached to
-* \author jgray
-* \ingroup JmgUtility
-*/
-class JMG_Utility_Timer_Damage_And_Teleport : public ScriptImpClass {
-	void Created(GameObject *obj);
-	void Timer_Expired(GameObject *obj,int number);
-};
-
-/*!
-* \brief Sends a custom if the object entering the zone has a weapon
-* \PlayerType - Player type the zone triggers for
-* \ScriptName - Name of the script needed to trigger the zone
-* \ID - ID to send the custom to, 0 sends to self, -1 sends to enter
-* \Custom - Custom message to send
-* \Param - Param to send
-* \Delay - Delay to add before sending custom
-* \TriggerOnce - Allows the script only to trigger the first time the zone is entered
-* \author jgray
-* \ingroup JmgUtility
-*/
-class JMG_Utility_Zone_Send_Custom_If_Has_Script : public ScriptImpClass {
-	void Entered(GameObject *obj,GameObject *enterer);
-};
-
-/*!
-* \brief Fades the screen and applies damage as the player gets further from the spot on the map, kills player if they wander outside a max range
-* \Warn_Distance - Distance at which the warning message appears on the HUD for infantry
-* \Damage_Distance - Distance at which the infantry starts taking damage
-* \Vehicle_Warn_Distance - Distance at which the warning message appears on the HUD for vehicle
-* \Vehicle_Damage_Distance - Distance at which the vehicle starts taking damage
-* \Aircraft_Warn_Distance - Distance at which the warning message appears on the HUD for aircraft
-* \Aircraft_Damage_Distance - Distance at which the aircraft starts taking damage
-* \Max_Survive_Distance - Distance at which anything the player is in (or the player their self) dies
-* \Warning_StringID - String ID to use for the HUD warning message
-* \Warning_Color - Color to display the warning HUD message
-* \Screen_Fade_Color - Color to fade the screen to
-* \author jgray
-* \ingroup JmgUtility
-*/
-class JMG_Utility_Damage_When_Outside_Of_Range : public ScriptImpClass {
-	float warnDistance;
-	float damageDistance;
-	float vehicleWarnDistance;
-	float vehicleDamageDistance;
-	float aircraftWarnDistance;
-	float aircraftDamageDistance;
-	float maxSurviveDistance;
-	Vector3 errorMessageColor;
-	Vector3 screenFadeColor;
-	Vector3 myPos;
-	int warnTime[128];
-	bool screenEffectOn[128];
-	int leavingFieldStringId;
-	void Created(GameObject *obj);
-	void Timer_Expired(GameObject *obj,int number);
-};
\ No newline at end of file
diff -uwrN source/scripts/renalert.cpp sourceold/scripts/renalert.cpp
--- source/scripts/renalert.cpp	2016-11-11 09:53:29.349803400 +1000
+++ sourceold/scripts/renalert.cpp	2016-10-31 07:17:12.627013500 +1000
@@ -112,15 +112,6 @@
 	Commands->Set_Is_Visible(obj,false);
 }
 
-void RA_Infantry_Spy::Detach(GameObject *obj)
-{
-	ScriptImpClass::Detach(obj);
-	if (Exe != 4)
-	{
-		Commands->Set_Is_Visible(obj,true);
-	}
-}
-
 //////////////RA_Infantry_NotSpy//////////////
 
 void RA_Infantry_NotSpy::Created(GameObject *obj)
@@ -1223,11 +1214,6 @@
 
 void RA_Base_Defense_Simple::Damaged(GameObject *obj, GameObject *damager, float amount)
 {
-	if(Get_Object_Type(obj)==-2)
-	{
-		return;
-	}
-
 	if (!damager || amount <= 0)
 	{
 		return;
@@ -1349,6 +1335,8 @@
 	}
 	else
 	{
+		//force ceasefire before checking to continue (helps fight client glitches... I hope...)
+		Commands->Action_Reset(obj, 100); //I have no idea what this number does...
 		attacking = false;
 		current_priority = 10;
 		GameObject *target = Commands->Find_Object(targetID);
@@ -1395,15 +1383,13 @@
 				}
 			}
 		}
-		if (call_attack && obj->As_DamageableGameObj()->Is_Enemy(target->As_DamageableGameObj())) //if attack and if call_attack was not turned false
+		if (call_attack) //if attack and if call_attack was not turned false
 		{
 			if (Commands->Get_Health(target))
 			{
 				Attack(obj, target);
 			}
 		}
-		else 
-			Commands->Action_Reset(obj, 100);
 	}
 	if (loop_count > 4)
 	{
@@ -1441,7 +1427,7 @@
 		FinalTarget = Select_Target(obj, FinalTarget); //Was Rate_Target
 	}
 	/****************Execute Final Attack****************/
-	if (FinalTarget && FinalTarget->As_DamageableGameObj()->Is_Enemy(obj->As_DamageableGameObj()))
+	if (FinalTarget && Commands->Get_Player_Type(FinalTarget) == PTTEAM(Commands->Get_Player_Type(obj))) //Check if I can still fire
 	{
 		targetID = Commands->Get_ID(FinalTarget); //remember new target, or re-remember old target
 		Vector3 objPos = Commands->Get_Position(obj);
@@ -1455,7 +1441,6 @@
 			params.Set_Basic(this,(float)current_priority, 100);
 			if (Adjust_For_Infantry(FinalTarget))
 			{
-				params.AttackObject = NULL;
 				params.Set_Attack(targetPos, range, 0, true);
 				params.AttackCheckBlocked = false;
 			}
@@ -1470,7 +1455,6 @@
 		}
 		else
 		{
-			Commands->Action_Reset(obj, 100);
 			attacking = false;
 			targetID = 0;
 			current_priority = 10;
@@ -1836,7 +1820,7 @@
 		return; //If its not the timer we're interested in, end now
 	}
 	bool call_attack = true;
-	if (!attacking && Is_Base_Powered(Get_Object_Type(obj)))	//skip facing action if attacking
+	if (!attacking)	//skip facing action if attacking
 	{
 		if (loop_count > 4) //only face new direction every 5th loop
 		{
@@ -1883,6 +1867,8 @@
 	}
 	else
 	{
+		//force ceasefire before checking to continue (helps fight client glitches... I hope...)
+		Commands->Action_Reset(obj, 100); //I have no idea what this number does...
 		attacking = false;
 		current_priority = 10;
 		GameObject *target = Commands->Find_Object(targetID);
@@ -1929,15 +1915,13 @@
 				}
 			}
 		}
-		if (call_attack && obj->As_DamageableGameObj()->Is_Enemy(target->As_DamageableGameObj())) //if attack and if call_attack was not turned false
+		if (call_attack) //if attack and if call_attack was not turned false
 		{
 			if (Commands->Get_Health(target))
 			{
 				Attack(obj, target);
 			}
 		}
-		else 
-			Commands->Action_Reset(obj, 100);
 	}
 	if (loop_count > 4)
 	{
@@ -1975,7 +1959,7 @@
 		FinalTarget = Select_Target(obj, FinalTarget); //Was Rate_Target
 	}
 	/****************Execute Final Attack****************/
-	if (FinalTarget && FinalTarget->As_DamageableGameObj()->Is_Enemy(obj->As_DamageableGameObj()))
+	if (FinalTarget && Commands->Get_Player_Type(FinalTarget) == PTTEAM(Commands->Get_Player_Type(obj))) //Check if I can still fire
 	{
 		targetID = Commands->Get_ID(FinalTarget); //remember new target, or re-remember old target
 		Vector3 objPos = Commands->Get_Position(obj);
@@ -1989,7 +1973,6 @@
 			params.Set_Basic(this,(float)current_priority, 100);
 			if (Adjust_For_Infantry(FinalTarget))
 			{
-				params.AttackObject = NULL;
 				params.Set_Attack(targetPos, range, 0, true);
 				params.AttackCheckBlocked = false;
 			}
@@ -2004,7 +1987,6 @@
 		}
 		else
 		{
-			Commands->Action_Reset(obj, 100);
 			attacking = false;
 			targetID = 0;
 			current_priority = 10;
@@ -2483,7 +2465,7 @@
 				}
 			}
 		}
-		if (call_attack && obj->As_DamageableGameObj()->Is_Enemy(target->As_DamageableGameObj())) //if attack and if call_attack was not turned false
+		if (call_attack) //if attack and if call_attack was not turned false
 		{
 			Attack_Charged(obj, target);
 		}
@@ -2524,7 +2506,7 @@
 		FinalTarget = Select_Target(obj, FinalTarget); //Was Rate_Target
 	}
 	/****************Execute Final Attack****************/
-	if (FinalTarget && FinalTarget->As_DamageableGameObj()->Is_Enemy(obj->As_DamageableGameObj()))
+	if (FinalTarget && Commands->Get_Player_Type(FinalTarget) == PTTEAM(Commands->Get_Player_Type(obj))) //Check if I can still fire
 	{
 		targetID = Commands->Get_ID(FinalTarget); //remember new target, or re-remember old target
 		Vector3 objPos = Commands->Get_Position(obj);
diff -uwrN source/scripts/renalert.h sourceold/scripts/renalert.h
--- source/scripts/renalert.h	2016-11-11 09:53:29.351803400 +1000
+++ sourceold/scripts/renalert.h	2016-10-31 07:17:12.627013500 +1000
@@ -22,7 +22,6 @@
 
 class RA_Infantry_Spy : public ScriptImpClass {
 	void Created(GameObject *obj);
-	void Detach(GameObject *obj);
 };
 
 class RA_Infantry_NotSpy : public ScriptImpClass {
diff -uwrN source/scripts/scripts.vcxproj sourceold/scripts/scripts.vcxproj
--- source/scripts/scripts.vcxproj	2016-11-19 11:41:30.859453700 +1000
+++ sourceold/scripts/scripts.vcxproj	2016-10-31 07:17:12.632013500 +1000
@@ -400,7 +400,6 @@
     <ClCompile Include="dan.cpp" />
     <ClCompile Include="DBIKScripts.cpp" />
     <ClCompile Include="DBScripts.cpp" />
-    <ClCompile Include="DB_Research_Terminals.cpp" />
     <ClCompile Include="DefinitionFactoryClass.cpp" />
     <ClCompile Include="DefinitionFactoryMgrClass.cpp" />
     <ClCompile Include="dllmain.cpp" />
@@ -579,8 +578,6 @@
     <ClInclude Include="DamageZoneGameObjDef.h" />
     <ClInclude Include="dan.h" />
     <ClInclude Include="DBIKScripts.h" />
-    <ClInclude Include="DB_General.h" />
-    <ClInclude Include="DB_Research_Terminals.h" />
     <ClInclude Include="DefenseObjectDefClass.h" />
     <ClInclude Include="Definition.h" />
     <ClInclude Include="DefinitionFactoryClass.h" />
diff -uwrN source/scripts/scripts.vcxproj.filters sourceold/scripts/scripts.vcxproj.filters
--- source/scripts/scripts.vcxproj.filters	2016-11-19 11:41:30.860453700 +1000
+++ sourceold/scripts/scripts.vcxproj.filters	2016-10-31 07:17:12.633013500 +1000
@@ -368,9 +368,6 @@
     <ClCompile Include="DBScripts.cpp">
       <Filter>01. Sources</Filter>
     </ClCompile>
-    <ClCompile Include="DB_Research_Terminals.cpp">
-      <Filter>01. Sources</Filter>
-    </ClCompile>
   </ItemGroup>
   <ItemGroup>
     <ClInclude Include="ArmedGameObj.h">
@@ -1258,12 +1255,6 @@
     <ClInclude Include="DBIKScripts.h">
       <Filter>01. Sources</Filter>
     </ClInclude>
-    <ClInclude Include="DB_Research_Terminals.h">
-      <Filter>01. Sources</Filter>
-    </ClInclude>
-    <ClInclude Include="DB_General.h">
-      <Filter>01. Sources</Filter>
-    </ClInclude>
   </ItemGroup>
   <ItemGroup>
     <None Include="documentation\cinematics.dox">
diff -uwrN source/scripts/weaponmgr.h sourceold/scripts/weaponmgr.h
--- source/scripts/weaponmgr.h	2016-12-10 07:57:58.701001000 +1000
+++ sourceold/scripts/weaponmgr.h	2016-10-31 07:17:12.646013500 +1000
@@ -96,7 +96,6 @@
 	safe_float		TargetingRange;//new
 	int             C4Preset;
 	bool			DisableHitscan;
-	bool			TrackingIgnoreTarget;
 
 #if (PARAM_EDITING_ON) || (DDBEDIT) || (W3DVIEWER)
     Vector3 ProjectileExtent;
@@ -163,8 +162,6 @@
 	bool			AreaEffectWeaponAffectEnemy;
 	bool			AreaEffectWeaponAffectNeutral;
 	StringClass		FirstPersonAnim;
-	bool            DoTiltWhileReloading;
-	bool			AllowEmptyShots;
 	friend class PresetDump;
 }; // 00AC
 
